题目描述
给你一份『词汇表』(字符串数组) words 和一张『字母表』(字符串) chars。
假如你可以用 chars 中的『字母』(字符)拼写出 words 中的某个『单词』(字符串),那么我们就认为你掌握了这个单词。
注意:每次拼写(指拼写词汇表中的一个单词)时,chars 中的每个字母都只能用一次。
返回词汇表 words 中你掌握的所有单词的 长度之和。
样例
示例 1:
输入:words = ["cat","bt","hat","tree"], chars = "atach"
输出:6
解释:
可以形成字符串 "cat" 和 "hat",所以答案是 3 + 3 = 6。
示例 2:
输入:words = ["hello","world","leetcode"], chars = "welldonehoneyr"
输出:10
解释:
可以形成字符串 "hello" 和 "world",所以答案是 5 + 5 = 10。
提示:
1 <= words.length <= 1000
1 <= words[i].length, chars.length <= 100
所有字符串中都仅包含小写英文字母
算法1 可以AC
(哈希查表) $O(n^2logn)$
预处理已知字母,出现一次就加一,放入哈希表中
对于每个word字符串,取出当前字符串的每个字符,每查一次,哈希表里该字符频度减一
时间复杂度
map 查询一次O(log n)遍历words数组得到s再遍历s得到c,O(n^2),
时间复杂度为O(n^2logn)
C++ 代码
class Solution {
public:
int countCharacters(vector<string>& words, string chars) {
int cnt = 0;
for(auto s:words)
{
map<char,int> m;
for(auto c:chars)m[c] += 1;
bool flag = true;
if(s.size()>chars.size())continue;
for(auto c:s)
{
if(!m[c])
{
flag = false;
break;
}
if(m[c])m[c]-=1;
}
if(flag)
{
cout << s << endl;
cnt += s.size();
}
}
return cnt;
}
};
算法2 TLE/MLE了
(爆搜)
对于chars长的字符全排列,string s不断加,当s和words中要匹配的字符串相等时直接返回true,当s的大小超过chars的大小时返回false,对chars的下标进行判重
因为TLE了,这里就不贴渣代码了,哈希的方法可以的就是慢,使用空间也大,各位大佬有没有更好的写法呢ORZ